package TreeSnatcher.GUI;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.geom.Rectangle2D;

import javax.swing.JButton;

//import TreeSnatcher.Utils.ColorConverter;

public class ColorButton extends JButton
{
	private static final long serialVersionUID = 1L;
	private Color fillColor;
	private Dimension d = new Dimension(22, 22);
	
	public ColorButton()
	{
		super();
		this.setMinimumSize(d);
		this.setPreferredSize(d);
		this.setSize(d);
		this.fillColor = Color.white;
	}
	
	public ColorButton(Color color)
	{
		new ColorButton();
		this.fillColor = color;
	}
	
	public void paintChildren(Graphics g)
	{
		super.paintChildren(g);
		Graphics2D g2 = (Graphics2D) g;
		Rectangle2D rect = new Rectangle2D.Float(3, 3, 16, 16);
		g2.setColor(fillColor);
		g2.fill(rect);
	}
	
	public void setColor(Color color) { this.fillColor = color; };
	public Color getColor() { return this.fillColor; };
	/*
	public float[] getHLSColor()
	{
		float R = fillColor.getRed()/255.0f;
		float G = fillColor.getGreen()/255.0f;
		float B = fillColor.getBlue()/255.0f;
		//System.out.println(""+R+", "+G+", "+B);
		return (float[]) ColorConverter.RGBtoHLS(R, G, B);
	}
	*/
	public Dimension getPreferredSize() { return d; };
}
