package TreeSnatcher.GUI;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

public class ControlsDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	protected JButton accept = new JButton("Accept");
	protected JButton revert = new JButton("Cancel");
	protected JButton preview = new JButton("Preview");
	protected JPanel slidersPanel;
	protected JPanel labelsPanel;
	protected boolean manipulated;
	
	public ControlsDialog() 
	{ 
		this("", null, true); 
	}
	
	public ControlsDialog(String title, java.awt.Frame parent, boolean modal)
	{
		super(parent, modal);
		this.setTitle(title);
		this.setResizable(false);
		this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE); // Not the most elegant solution, better hide the buttons
		this.setAlwaysOnTop(true);
		JPanel jpButtons = new JPanel();
		jpButtons.add(accept);
		jpButtons.add(preview);
		jpButtons.add(revert);
		
		slidersPanel = new JPanel();
		labelsPanel = new JPanel();
		labelsPanel.setLayout(new BorderLayout());
		JPanel jpGeneral = new JPanel();
		jpGeneral.setLayout(new BorderLayout());
		jpGeneral.setBorder(BorderFactory.createTitledBorder("Select Parameters"));
		jpGeneral.add(labelsPanel, BorderLayout.WEST);
		jpGeneral.add(slidersPanel, BorderLayout.CENTER);
		
		getContentPane().add(jpButtons, BorderLayout.SOUTH);
		getContentPane().add(jpGeneral, BorderLayout.CENTER);
		
		manipulated = false; // No image manipulation has occurred
	}
	
	public JPanel getSlidersPanel() { return this.slidersPanel; };
	public JPanel getLabelsPanel() { return this.labelsPanel; };
	
	/*
	public void removeMinMaxClose(Component comp)  
	{  
		System.out.println("Component: "+comp);
	  if (comp instanceof JButton)  
	  {  
	    String accName = ((JButton) comp).getAccessibleContext().getAccessibleName();  
	    System.out.println(accName);   
	    if ((accName.equals("Maximize") || accName.equals("Iconify") || accName.equals("Close"))) comp.getParent().remove(comp);  
	  }  
	  
	  if (comp instanceof Container)  
	  {  
		  System.out.println("Container");
	    Component[] comps = ((Container)comp).getComponents();  
	    for(int x = 0, y = comps.length; x < y; x++)  
	    {  
	      removeMinMaxClose(comps[x]);  
	      
	    }  
	  }  
	}  
	*/
	//public Dimension getPreferredSize() { return new Dimension(230, 200); };
}
