package TreeSnatcher.GUI;

import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.io.File;

import TreeSnatcher.Utils.Preferences;

public class FancyCursors 
{
	Wizard wizard;
	Cursor panelCursor;
	Cursor pencilCursor;
	Cursor rubberCursor;
	Cursor defaultCursor;
	Cursor crosshairCursor;
	Cursor handCursor;
	Cursor pipetteCursor;
	Cursor fillCursor;
	Cursor blackLineCursor;
	Cursor whiteLineCursor;
	Cursor curve2DCursor;
	Cursor boxSelCursor;
	Cursor lineSelCursor;
	Cursor dragCursor;
	Cursor stencilCursor;
	
	public FancyCursors(Wizard wiz)
	{
		// Mac OS X Hot Spots: -4, -4
		this.wizard = wiz;
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Image cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/MetricsCursor.GIF"));
		Point cursorHotSpot = new Point(15, 15);
		panelCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Standard");
		
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/BoxSelCursor.GIF"));
		cursorHotSpot = new Point(21, 15);
		boxSelCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Box");
		
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/LineSelCursor.GIF"));
		cursorHotSpot = new Point(21, 15);
		lineSelCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "LineSel");
		
		cursorHotSpot = new Point(8, 26);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/PencilCursor.GIF"));
		pencilCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Pencil");
		
		cursorHotSpot = new Point(8, 26);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/BlackLineCursor.GIF"));
		blackLineCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "BlackLine");
		
		cursorHotSpot = new Point(8, 26);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/WhiteLineCursor.GIF"));
		whiteLineCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "WhiteLine");
		
		cursorHotSpot = new Point(8, 26);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/Curve2DCursor.GIF"));
		curve2DCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Curve2D");
		
		cursorHotSpot = new Point(8, 25);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/RubberCursor.GIF"));
		rubberCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Rubber");
		
		cursorHotSpot = new Point(1, 28);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/PipetteCursor.GIF"));
		pipetteCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Pipette");
		
		cursorHotSpot = new Point(2, 23);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/FillCursor.GIF"));
		fillCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Fill");
		
		cursorHotSpot = new Point(21, 16);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/DragCursor.GIF"));
		dragCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Drag");
		
		cursorHotSpot = new Point(1, 1);
		cursorImage = toolkit.getImage(FancyCursors.class.getResource("/Cursors/StencilCursor.GIF"));
		stencilCursor = toolkit.createCustomCursor(cursorImage, cursorHotSpot, "Stencil");
	}
	
	public Cursor getPanelCursor() { return this.panelCursor; };
	public Cursor getBoxSelCursor() { return this.boxSelCursor; };
	public Cursor getLineSelCursor() { return this.lineSelCursor; };
	public Cursor getPencilCursor() { return this.pencilCursor; };
	public Cursor getBlackLineCursor() { return this.blackLineCursor; };
	public Cursor getWhiteLineCursor() { return this.whiteLineCursor; };
	public Cursor getCurve2DCursor() { return this.curve2DCursor; };
	public Cursor getRubberCursor() { return this.rubberCursor; };
	public Cursor getPipetteCursor() { return this.pipetteCursor; };
	public Cursor getFillCursor() { return this.fillCursor; };
	public Cursor getDragCursor() { return this.dragCursor; };
	public Cursor getStencilCursor() { return this.stencilCursor; };
	public Cursor getDefaultCursor() { return new Cursor(Cursor.DEFAULT_CURSOR); };
	public Cursor getHandCursor() { return new Cursor(Cursor.HAND_CURSOR); };
	public Cursor getCrosshairCursor() { return new Cursor(Cursor.CROSSHAIR_CURSOR); };
	public Cursor getWaitCursor() { return new Cursor(Cursor.WAIT_CURSOR); };
}
