package TreeSnatcher.GUI;

import java.awt.Color;
import java.awt.Point;

public class Pixel
{
	Point location;
	Color col;
	
	public Pixel(Point p, Color c)
	{
		this.location = p;
		this.col = c;
	}
	
	public Pixel(int x, int y, Color c)
	{
		this.location = new Point(x, y);
		this.col = c;
	}
	
	public Pixel(int x, int y, int color)
	{
		this.location = new Point(x, y);
		this.col = new Color(color);
	}
	
	public Pixel(int x, int y)
	{
		new Pixel(x, y, null);
	}
	
	public Pixel(Point p)
	{
		new Pixel(p, null);
	}
	
	public Point getLocation() { return location; };
	public int getX() { return location.x; };
	public int getY() { return location.y; };
	public Color getColor() { return col; };
	public int getRGB() { return col.getRGB(); };
	public String toString()
	{
		String s = "\nPixel at ("+location.x+", "+location.y+")";
		if (col != null) s = s + " with RGB color ("+col.getRed()+", "+col.getGreen()+", "+col.getBlue()+")";
		return s;
	}
}
