package TreeSnatcher.GUI;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import TreeSnatcher.Utils.Preferences;

public class ReadMePanel extends JFrame
{
	private static final long serialVersionUID = 1L;
	
	public ReadMePanel()
	{
		BufferedReader in = null;
		Vector<String> text = new Vector<String>();;
		String path = Preferences.programPath+File.separator+"tsReadme.txt";
		String s = "";
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		
		File manualFile = new File(path);
		if (manualFile.exists())
		{
			try // Stream the content of the text file into Vector text
			{   
				in = new BufferedReader(new InputStreamReader(new FileInputStream(manualFile)));
				while(null != (s = in.readLine())) text.add(s);
			} 
			catch (FileNotFoundException ex) {}
			catch (IOException ix) {};
		}
		
		JTextArea textArea = new JTextArea();
		textArea.setEditable(false);
		textArea.setFont(new Font("Serif", Font.PLAIN, 16));
		textArea.setLineWrap(true);
		textArea.setWrapStyleWord(true);
		
		if (text.size() < 2) textArea.append("Could not open file "+path);
		else
		{
			Iterator<String> textIt = text.iterator();
			while (textIt.hasNext()) textArea.append(textIt.next()+"\n");
		}
		JScrollPane scrollPane = new JScrollPane(textArea);
	
		scrollPane.doLayout();
		this.setLayout(new BorderLayout(15, 15));
		this.add(scrollPane);
		this.setPreferredSize(new Dimension(800, 600));
		this.setSize(800, 600);
		this.setIconImage(toolkit.getImage(Image.class.getResource("/Icons/wood32.png")));
		this.setVisible(true);
		this.setAlwaysOnTop(true);
	}
}
