 package TreeSnatcher.GUI;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.image.BufferedImage;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;

public class StatusBar
{
	private JLabel messageLabel, coordsLabel;
	private String formerMessage = "";
	private JPanel panel;
	
	public StatusBar(JFrame owner, JPanel panel)
	{
		coordsLabel = new JLabel("");
		coordsLabel.setFont(new Font("Arial", Font.PLAIN, 12)); // TODO: Font zentral von Utility beziehen
		coordsLabel.setForeground(Color.black);
		coordsLabel.setVerticalTextPosition(JLabel.BOTTOM);
		coordsLabel.setHorizontalTextPosition(JLabel.LEADING);
		coordsLabel.setMinimumSize(new Dimension(285, 20));
		coordsLabel.setMaximumSize(new Dimension(285, 20));
		coordsLabel.setBorder(BorderFactory.createEtchedBorder());
		
		messageLabel = new JLabel("Ready");
		messageLabel.setForeground(Color.red.darker());
		messageLabel.setVerticalTextPosition(JLabel.BOTTOM);
		messageLabel.setHorizontalTextPosition(JLabel.LEADING);
		messageLabel.setMinimumSize(new Dimension(panel.getWidth()-coordsLabel.getWidth()-5, 20));
		messageLabel.setSize(new Dimension(panel.getWidth()-coordsLabel.getWidth()-5, 20));
		messageLabel.setMinimumSize(new Dimension(panel.getWidth()-coordsLabel.getWidth()-5, 20));
		messageLabel.setPreferredSize(new Dimension(panel.getWidth()-coordsLabel.getWidth()-5, 20));
		messageLabel.setBorder(BorderFactory.createEtchedBorder());
		messageLabel.setFont(new Font("Arial", Font.PLAIN, 12)); // TODO: Font zentral von Utility beziehen
		
		panel.setBorder(BorderFactory.createLoweredBevelBorder());
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		//panel.add(Box.createHorizontalGlue());
		panel.add(coordsLabel);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(messageLabel);

		panel.setMinimumSize(new Dimension(panel.getWidth(), 24));
		panel.setPreferredSize(panel.getMinimumSize());
	}
	
	
	public void showMessage(String message, BufferedImage image, Point mc)
	{
		// Display first the component coordinates and the color in the image that is beneath the mouse location
		// Then append the message
		String locStr = new String();
		if (image != null)
		{
			locStr = "Point ("+mc.x+", "+mc.y+")";
			Color c = null;
			try
			{
				c = new Color(image.getRGB(mc.x, mc.y));
			}
			catch (ArrayIndexOutOfBoundsException ea) {};
				
			if (c != null) locStr += " has RGB-Color ("+c.getRed()+", "+c.getGreen()+", "+c.getBlue()+")";
			else locStr += " is outside the image";
		}
		
		if (locStr != null) coordsLabel.setText(locStr);
		if (message != "") messageLabel.setText(message);
		formerMessage = message;
	}
	
	public void reset() 
	{ 
		showMessage("", null, null);
	}
}

 